#NoTrayIcon
#include-once
#CS ----------------------------------------------------------------------------
	AutoIt Version: 3.3.6.1
	Author:         GaRy delaMer
	DDTM-34/DML
	Script Function:
#CE ----------------------------------------------------------------------------
#Region ;**** Options AutoIt							****
Opt("MustDeclareVars", 1)
Opt("GUICloseOnESC", 1)
Opt("GUIOnEventMode", 1)
Opt("WinSearchChildren", 1)
Opt("WinTextMatchMode", 1)
Opt("WinTitleMatchMode", -2)
#EndRegion ;**** Options AutoIt							****
#Region ;**** Include AutoIt							****
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <TreeViewConstants.au3>
#include <WindowsConstants.au3>

#include <Array.au3>
#include <IE.au3>
_IEErrorHandlerRegister()
#include <Misc.au3>

#include <GuiMenu.au3>
#include <GuiStatusBar.au3>
#include <GuiTreeView.au3>
#EndRegion ;**** Include AutoIt							****
#Region ;**** Include My Objects						****
#include "AutoItObject.au3"
#include "AO_Collection.au3"
#include "AO_GnrateurCode.au3"
#EndRegion ;**** Include My Objects						****
#Region ;**** Include My UDFs							****
#include <Au3SyntaxHighlight.au3>
Func _IsChecked($h_ctrl)
	Return BitAND(GUICtrlRead($h_ctrl), $GUI_CHECKED) = $GUI_CHECKED
EndFunc   ;==>_IsChecked
#EndRegion ;**** Include My UDFs							****
#Region ;**** Variables									****
Global Const $APPLI_TITRE = "Gnrateur de code: AutoItObject"
_Singleton($APPLI_TITRE)
Global Enum $idCmd_Delete = 10000
#EndRegion ;**** Variables									****
Global $oIE = _IECreateEmbedded()
#Region ### START Koda GUI section ### Form=
Global $GUIMain = GUICreate("Gnrateur d'objet: AutoIt Object", 1272, 987, -1, -1)
Global $Menu1 = GUICtrlCreateMenu("&Fichier")
Global $MenuItem1 = GUICtrlCreateMenuItem("&Enregistrer sous...", $Menu1)
GUICtrlCreateMenuItem("", $Menu1)
Global $MenuItem2 = GUICtrlCreateMenuItem("&Quitter", $Menu1)
GUISetBkColor(0x696969)
Global $GUIMain_TV = GUICtrlCreateTreeView(10, 215, 301, 721, BitOR($GUI_SS_DEFAULT_TREEVIEW, $TVS_FULLROWSELECT))
GUICtrlCreateGroup("Objet", 10, 10, 300, 196)
Global $GUIMain_ObjectName = GUICtrlCreateInput("ObjectName", 20, 30, 281, 21)
Global $Chk_Destructor = GUICtrlCreateCheckbox("Ajouter le destructeur", 20, 150, 165, 17)
Global $Chk_Enum = GUICtrlCreateCheckbox("Ajouter un enumrateur", 20, 175, 165, 17)
Global $Chk_Includes = GUICtrlCreateCheckbox("Ajouter les includes", 20, 60, 165, 17)
Global $Chk_Errors = GUICtrlCreateCheckbox("Ajouter la gestion des erreurs", 20, 85, 165, 17)
Global $Chk_Colors = GUICtrlCreateCheckbox("Utiliser la coloration du code", 20, 110, 165, 17)
Global $GUIMain_Bt_Copy = GUICtrlCreateButton("Copier le code", 215, 105, 90, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group2 = GUICtrlCreateGroup("", 320, 10, 745, 80)
Global $GUIMain_Lbl_Name = GUICtrlCreateLabel("Nom", 330, 35, 36, 17)
Global $GUIMain_Lbl_Value = GUICtrlCreateLabel("Valeur", 330, 65, 50, 17)
Global $GUIMain_Inpt_Name = GUICtrlCreateInput("", 390, 30, 321, 21)
Global $GUIMain_Cb_Scope = GUICtrlCreateCombo("", 760, 30, 145, 25, BitOR($CBS_DROPDOWN, $CBS_AUTOHSCROLL))
Global $GUIMain_Lbl_Scope = GUICtrlCreateLabel("Scope", 720, 35, 35, 17)
Global $GUIMain_Inpt_Value = GUICtrlCreateInput("", 390, 60, 666, 21)
Global $GUIMain_Bt_Add = GUICtrlCreateButton("Ajouter la proprit", 915, 25, 140, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $hStatusBar = _GUICtrlStatusBar_Create($GUIMain)
Global $GUIActiveX = GUICtrlCreateObj($oIE, 320, 100, 935, 835)

GUICtrlSetResizing($GUIMain_TV, $GUI_DOCKLEFT + $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKBOTTOM)
GUICtrlSetState($Group2, $GUI_HIDE)
GUICtrlSetState($GUIMain_Lbl_Name, $GUI_HIDE)
GUICtrlSetState($GUIMain_Lbl_Scope, $GUI_HIDE)
GUICtrlSetState($GUIMain_Lbl_Value, $GUI_HIDE)
GUICtrlSetState($GUIMain_Inpt_Name, $GUI_HIDE)
GUICtrlSetState($GUIMain_Cb_Scope, $GUI_HIDE)
GUICtrlSetState($GUIMain_Inpt_Value, $GUI_HIDE)
GUICtrlSetState($GUIMain_Bt_Add, $GUI_HIDE)
GUICtrlSetState($Chk_Destructor, $GUI_CHECKED)
GUICtrlSetState($Chk_Includes, $GUI_CHECKED)
GUICtrlSetState($Chk_Errors, $GUI_CHECKED)

GUISetOnEvent($GUI_EVENT_CLOSE, "GUIMain_Close")

GUICtrlSetOnEvent($MenuItem1, "GUIMain_SaveAs")
GUICtrlSetOnEvent($MenuItem2, "GUIMain_Close")
GUICtrlSetOnEvent($GUIMain_ObjectName, "GUIMain_CodeUpdate")
GUICtrlSetOnEvent($Chk_Destructor, "GUIMain_CodeUpdate")
GUICtrlSetOnEvent($Chk_Enum, "GUIMain_CodeUpdate")
GUICtrlSetOnEvent($Chk_Includes, "GUIMain_CodeUpdate")
GUICtrlSetOnEvent($Chk_Errors, "GUIMain_CodeUpdate")
GUICtrlSetOnEvent($Chk_Colors, "GUIMain_CodeUpdate")
GUICtrlSetOnEvent($GUIMain_Bt_Copy, "GUIMain_CodeCopy")
GUICtrlSetOnEvent($GUIMain_Bt_Add, "GUIMain_AddUpdate")

GUIRegisterMsg($WM_NOTIFY, "_Events_WM_Notify")
GUIRegisterMsg($WM_SIZE, "_Events_WM_SIZE")

GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

_AutoItObject_Startup()
Global $oScript = AO_ScriptObject(GUICtrlRead($GUIMain_ObjectName))
Global $GUIMain_TV_R = GUICtrlCreateTreeViewItem("Objet: " & GUICtrlRead($GUIMain_ObjectName), $GUIMain_TV)
; Proprits par dfaut
Global $GUIMain_TV_P = GUICtrlCreateTreeViewItem("Proprits", $GUIMain_TV_R)
Global $GUIMain_TV_P1 = GUICtrlCreateTreeViewItem("Id", $GUIMain_TV_P)
Global $GUIMain_TV_P2 = GUICtrlCreateTreeViewItem("Name", $GUIMain_TV_P)
$oScript.Properties.Add($GUIMain_TV_P1, "Id", -1, -1)
$oScript.Properties.Add($GUIMain_TV_P2, "Name")
; Methodes par dfaut
Global $GUIMain_TV_M = GUICtrlCreateTreeViewItem("Mthodes", $GUIMain_TV_R)
Global $GUIMain_TV_M1 = GUICtrlCreateTreeViewItem("Debug", $GUIMain_TV_M)
Local $Args = "$bReturn = False, $ScriptName = @ScriptName, $LineNumber = @ScriptLineNumber"
$oScript.Methods.Add($GUIMain_TV_M1, "Debug", False, $Args)
$oScript.Method($GUIMain_TV_M1).Function = "_Debug"
$oScript.Method($GUIMain_TV_M1).Code = "	Local $Return = StringFormat(""Name: '%s' \n"",  _" & @CRLF & _
		"			$Object.Name)" & @CRLF & _
		"	If $AO_FlagDebug Then ConsoleWrite($Return)" & @CRLF & _
		"	If $bReturn Then Return $Return" & @CRLF & _
		"	ConsoleWrite($Return)"

_GUICtrlTreeView_Expand($GUIMain_TV)
_IENavigate($oIE, 'about:blank')
GUIMain_CodeUpdate()

While 1
	Sleep(100)
WEnd

#Region	;;;		GUIMain
#EndRegion	;;;		GUIMain

Func _Events_TV_ContextMenu($hWnd, $Item, $idCmd)
	#forceref $hWnd, $Item, $idCmd
	Local $hWndTreeview = $GUIMain_TV
	If Not IsHWnd($GUIMain_TV) Then $hWndTreeview = GUICtrlGetHandle($GUIMain_TV)
	Switch $hWnd
		Case $hWndTreeview
			Switch $idCmd
				Case $idCmd_Delete
					Local $Param = _GUICtrlTreeView_GetItemParam($hWnd, $Item)
					Switch _GUICtrlTreeView_GetParentParam($hWnd, $Item)
						Case $GUIMain_TV_M
							$oScript.Methods.Delete($Param)
						Case $GUIMain_TV_P
							$oScript.Properties.Delete($Param)
						Case Else
							Return
					EndSwitch
					_GUICtrlTreeView_Delete($hWnd, $Item)
					GUIMain_CodeUpdate()
			EndSwitch
	EndSwitch
EndFunc   ;==>_Events_TV_ContextMenu
Func _Events_WM_Notify($hWnd, $Msg, $wParam, $lParam)
	#forceref $hWnd, $Msg, $wParam
	Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $hWndTreeview
	$hWndTreeview = $GUIMain_TV
	If Not IsHWnd($GUIMain_TV) Then $hWndTreeview = GUICtrlGetHandle($GUIMain_TV)

	$tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
	$iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
	$iCode = DllStructGetData($tNMHDR, "Code")
	Switch $hWndFrom
		Case $hWndTreeview
			Switch $iCode
				Case $NM_CLICK
					Local $tPoint = _WinAPI_GetMousePos(True, $hWndFrom), $tHitTest
					$tHitTest = _GUICtrlTreeView_HitTestEx($hWndFrom, DllStructGetData($tPoint, 1), DllStructGetData($tPoint, 2))
					Local $hItem = DllStructGetData($tHitTest, 'Item')
					_GUICtrlTreeView_SelectItem($hWndFrom, $hItem)
					GUIMain_TV_OnClick($hWndFrom, $hItem)
				Case $NM_RCLICK
					Local $tPoint = _WinAPI_GetMousePos(True, $hWndFrom), $tHitTest
					$tHitTest = _GUICtrlTreeView_HitTestEx($hWndFrom, DllStructGetData($tPoint, 1), DllStructGetData($tPoint, 2))
					Local $hItem = DllStructGetData($tHitTest, 'Item')
					_GUICtrlTreeView_SelectItem($hWndFrom, $hItem)
					GUIMain_TV_ContextMenu($hWndFrom, $hItem)
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_Events_WM_Notify
Func _Events_WM_SIZE($hWnd, $Msg, $wParam, $lParam)
	#forceref $hWnd, $Msg, $wParam, $lParam
	_GUICtrlStatusBar_Resize($hStatusBar)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_Events_WM_SIZE

;	GUI_Main
Func GUIMain_AddUpdate()
	Switch GUICtrlRead(@GUI_CtrlId)
		Case "Ajouter la Methode"
			$oScript.Methods.Add(GUICtrlCreateTreeViewItem(GUICtrlRead($GUIMain_Inpt_Name), $GUIMain_TV_M), _
					GUICtrlRead($GUIMain_Inpt_Name), GUICtrlRead($GUIMain_Cb_Scope), GUICtrlRead($GUIMain_Inpt_Value))
		Case "Modifier la Methode"
			Local $oMethod = $oScript.Method(GUICtrlRead($GUIMain_TV))
			Local $aName = StringSplit(GUICtrlRead($GUIMain_Inpt_Name), "|")
			$oMethod.Name = $aName[1]
			$oMethod.Function = $aName[1]
			If $aName[0] > 1 Then $oMethod.Function = $aName[2]
			$oMethod.Private = _Iif(GUICtrlRead($GUIMain_Cb_Scope) <> "", True, False)
			$oMethod.Args = GUICtrlRead($GUIMain_Inpt_Value)
			_GUICtrlTreeView_SetText($GUIMain_TV, GUICtrlRead($GUIMain_TV), $oMethod.Name)
		Case "Ajouter la proprit"
			$oScript.Properties.Add(GUICtrlCreateTreeViewItem(GUICtrlRead($GUIMain_Inpt_Name), $GUIMain_TV_P), _
					GUICtrlRead($GUIMain_Inpt_Name), GUICtrlRead($GUIMain_Cb_Scope), GUICtrlRead($GUIMain_Inpt_Value))
		Case "Modifier la proprit"
			Local $oProperty = $oScript.Property(GUICtrlRead($GUIMain_TV))
			$oProperty.Name = GUICtrlRead($GUIMain_Inpt_Name)
			$oProperty.Scope = GUICtrlRead($GUIMain_Cb_Scope)
			$oProperty.Value = GUICtrlRead($GUIMain_Inpt_Value)
			_GUICtrlTreeView_SetText($GUIMain_TV, GUICtrlRead($GUIMain_TV), $oProperty.Name)
	EndSwitch
	GUIMain_CodeUpdate()
EndFunc   ;==>GUIMain_Add
Func GUIMain_CodeCopy()
	ClipPut($oScript.Code)
EndFunc   ;==>GUIMain_CopyCode
Func GUIMain_CodeUpdate()
	$oScript.Destructor = _isChecked($Chk_Destructor)
	$oScript.Includes = _isChecked($Chk_Includes)
	$oScript.Enum = _isChecked($Chk_Enum)
	$oScript.Error = _isChecked($Chk_Errors)
	$oScript.Name = GUICtrlRead($GUIMain_ObjectName)
	_GUICtrlTreeView_SetText($GUIMain_TV, $GUIMain_TV_R, "Objet: " & $oScript.Name)
	If _isChecked($Chk_Colors) Then
		SplashTextOn("Mise  jour du code", "Mise en forme du code, patientez !!!", 200, 80)
		$iAu3SH_AddURLs = 0
		$sAu3_Styles_File = "au3.styles.properties"
		$sAu3_Keywords_File = "au3.keywords.properties"
		Local $sAu3Syntax_HighlightedCode = _Au3_SyntaxHighlight_Proc($oScript.Code, 0)
		_IEDocWriteHTML($oIE, $sAu3Syntax_HighlightedCode)
		SplashOff()
	Else
		_IEDocWriteHTML($oIE, "<pre>" & $oScript.Code & "<pre>")
	EndIf
EndFunc   ;==>GUIMain_UpdateCode
Func GUIMain_Close()
	$oScript = 0
	_AutoItObject_Shutdown()
	Exit
EndFunc   ;==>GUIMain_Close
Func GUIMain_SaveAs()
	Local $File = FileSaveDialog("Enregistrer le script sous...", @WorkingDir, "Scripts AutoIt (*.au3)", 2 + 16, _
			"AO_" & GUICtrlRead($GUIMain_ObjectName) & ".au3", $GUIMain)
	If $File Then
		Local $hFile = FileOpen($File, 2)
		FileWrite($hFile, $oScript.Code)
		FileClose($hFile)
	EndIf
EndFunc   ;==>GUIMain_SaveAs
Func GUIMain_SetShow()

EndFunc   ;==>GUIMain_SetShow
Func GUIMain_TV_ContextMenu($hWnd, $Item)
	Local $Text
	Switch _GUICtrlTreeView_GetParentParam($hWnd, $Item)
		Case $GUIMain_TV_M
			$Text = "Methode"
		Case $GUIMain_TV_P
			$Text = "Proprit"
		Case Else
			Return
	EndSwitch
	Local $hMenu = _GUICtrlMenu_CreatePopup(1)
	_GUICtrlMenu_AddMenuItem($hMenu, "Supprimer la " & $Text, $idCmd_Delete)
	; ========================================================================
	; Shows how to capture the context menu selections
	; ========================================================================
	Local $idCmd = _GUICtrlMenu_TrackPopupMenu($hMenu, $hWnd, -1, -1, 1, 1, 2)
	_GUICtrlMenu_DestroyMenu($hMenu)
	_Events_TV_ContextMenu($hWnd, $Item, $idCmd)
EndFunc   ;==>GUIMain_TV_ContextMenu
Func GUIMain_TV_OnClick($hWnd, $Item)
	Local $Text = "Objet"
	GUICtrlSetState($Group2, $GUI_HIDE)
	GUICtrlSetState($GUIMain_Lbl_Name, $GUI_HIDE)
	GUICtrlSetState($GUIMain_Lbl_Scope, $GUI_HIDE)
	GUICtrlSetState($GUIMain_Lbl_Value, $GUI_HIDE)
	GUICtrlSetState($GUIMain_Inpt_Name, $GUI_HIDE)
	GUICtrlSetState($GUIMain_Cb_Scope, $GUI_HIDE)
	GUICtrlSetState($GUIMain_Inpt_Value, $GUI_HIDE)
	GUICtrlSetState($GUIMain_Bt_Add, $GUI_HIDE)
	If _GUICtrlTreeView_GetItemParam($hWnd, $Item) = $GUIMain_TV_R Then Return
	Switch _GUICtrlTreeView_GetParentParam($hWnd, $Item)
		Case $GUIMain_TV_M
			$Text = "Methode"
			GUICtrlSetData($GUIMain_Bt_Add, "Modifier la Methode")
			Local $oMethod = $oScript.Method(_GUICtrlTreeView_GetItemParam($hWnd, $Item))
			GUICtrlSetData($GUIMain_Inpt_Name, $oMethod.Name & "|" & $oMethod.Function)
			GUICtrlSetData($GUIMain_Cb_Scope, "")
			GUICtrlSetData($GUIMain_Cb_Scope, "|Private")
			GUICtrlSetData($GUIMain_Cb_Scope, _Iif($oMethod.Private, "Private", "|Private"))
			GUICtrlSetData($GUIMain_Inpt_Value, $oMethod.Args)
			GUICtrlSetData($GUIMain_Lbl_Value, "Arguments")
		Case $GUIMain_TV_P
			$Text = "Proprit"
			Local $oProperty = $oScript.Property(_GUICtrlTreeView_GetItemParam($hWnd, $Item))
			GUICtrlSetData($GUIMain_Bt_Add, "Modifier la proprit")
			GUICtrlSetData($GUIMain_Inpt_Name, $oProperty.Name)
			GUICtrlSetData($GUIMain_Cb_Scope, "")
			GUICtrlSetData($GUIMain_Cb_Scope, "$ELSCOPE_PUBLIC|$ELSCOPE_READONLY|$ELSCOPE_PRIVATE")
			GUICtrlSetData($GUIMain_Cb_Scope, $oProperty.Scope)
			GUICtrlSetData($GUIMain_Inpt_Value, $oProperty.Value)
			GUICtrlSetData($GUIMain_Lbl_Value, "Valeur")
		Case Else
			GUICtrlSetData($GUIMain_Inpt_Name, "")
			GUICtrlSetData($GUIMain_Cb_Scope, "")
			GUICtrlSetData($GUIMain_Inpt_Value, "")
			Switch _GUICtrlTreeView_GetItemParam($hWnd, $Item)
				Case $GUIMain_TV_M
					$Text = "Methodes"
					GUICtrlSetData($GUIMain_Bt_Add, "Ajouter la Methode")
					GUICtrlSetData($GUIMain_Cb_Scope, "|Private")
					GUICtrlSetData($GUIMain_Lbl_Value, "Arguments")
				Case $GUIMain_TV_P
					$Text = "Proprits"
					GUICtrlSetData($GUIMain_Bt_Add, "Ajouter la proprit")
					GUICtrlSetData($GUIMain_Cb_Scope, "$ELSCOPE_PUBLIC|$ELSCOPE_READONLY|$ELSCOPE_PRIVATE")
					GUICtrlSetData($GUIMain_Lbl_Value, "Valeur")
			EndSwitch
	EndSwitch
	GUICtrlSetData($Group2, $Text)
	GUICtrlSetState($Group2, $GUI_SHOW)
	GUICtrlSetState($GUIMain_Lbl_Name, $GUI_SHOW)
	GUICtrlSetState($GUIMain_Lbl_Scope, $GUI_SHOW)
	GUICtrlSetState($GUIMain_Cb_Scope, $GUI_SHOW)
	GUICtrlSetState($GUIMain_Inpt_Name, $GUI_SHOW)
	GUICtrlSetState($GUIMain_Bt_Add, $GUI_SHOW)
	GUICtrlSetState($GUIMain_Lbl_Value, $GUI_SHOW)
	GUICtrlSetState($GUIMain_Inpt_Value, $GUI_SHOW)
EndFunc   ;==>GUIMain_TV_OnClick
